/*
  Ŀ
 ݳ  CLASE & OBJETO : GAUGE                                             
 ݳ  DESCRIPCION    : Clase gauge para controlar progreso de Procesos.  
 ݳ  AUTOR          : David Romn Guerrero                              
 ݳ  Switches       : /n/w/l/es2                                        
 ݳ  Created        : 26 de Enero de 1996                               
 ݳ  Last Update    : 26 de Enero de 1996                               
 
 
*/
#Include "Class(y).ch"

#Define COLORTIT "N/BG"
#Define COLORBAR "R+/BG"
#Define COLORCOM "GR+/BG"

CREATE CLASS Gauge

PROTECTED:
   VAR cScreen
   VAR nCiclos
   VAR nFilaInf
   VAR nColLeft
   VAR nColRight
   VAR nColComodin
   VAR nColPorcentaje
   VAR nPorcAvanze                // Porcentaje de avanze
   VAR nLongBar
   VAR lFrame                     // Flag para dibujar la caja

   METHOD drawEnv
   METHOD show
   METHOD calcCoord
   METHOD calcPorc                // Calcula porcentaje de avanze

EXPORT:
   VAR cTitulo
   VAR cComodin                   // Caracter de rastreo
   VAR nFilaSup
   VAR nPorcInc                   // Incremento para porcentaje de avanze
   VAR nLimite                    // Limite del incremento

   METHOD init
   METHOD trace
   METHOD hide

END CLASS


/*
  Ŀ
 ݳ  INIT()  Inicializa atributos del Objeto.  
 
 
*/
METHOD init( cTitulo, nFila )
   //... Verificacin de valores
   cTitulo := IF( cTitulo != NIL, cTitulo, " Progreso " )
   nFila := IF( nFila != NIL, nFila, 09 )

   ::cTitulo  := cTitulo
   ::cComodin := ""
   ::nCiclos  := 0
   ::nFilaSup := nFila
   ::nLimite  := 100
   ::nPorcInc := 3
   ::nLongBar := 0
   ::lFrame   := .F.

   RETURN( Self )


/*
  Ŀ
 ݳ  TRACE()  Coordinar eventos para mostrar avanze.  
 
 
*/
METHOD trace()
   LOCAL cOldDev := Set( _SET_DEVICE ) ,nIncr

   IF !::lFrame
      Set( _SET_DEVICE, "SCREEN" )
      ::drawEnv()
      ::lFrame := .T.
      Set( _SET_DEVICE, cOldDev )
   ENDIF

   ++::nCiclos
   ::calcPorc()
   nIncr := Int( Int(::nPorcAvanze) / ::nPorcInc )
   ::show( nIncr)

   RETURN( NIL )


/*
  Ŀ
 ݳ  HIDE()  Oculta el Objeto.  
 
 
*/
METHOD hide()
   ::nPorcAvanze := 100
   ::show( ::nLongBar )
   Inkey( .2 )
   RestScreen( ::nFilaSup, ::nColLeft, ::nFilaInf, ::nColRight, ::cScreen )

   RETURN( NIL )


/*
  Ŀ
 ݳ  SHOW()  Proceso de visualizacin del avanze.  
 
 
*/
METHOD show( nIncr )
   LOCAL cOldDev := Set( _SET_DEVICE ), cBarra

   Set( _SET_DEVICE, "SCREEN" )
   IF !::lFrame
      ::drawEnv()
      ::lFrame := .T.
   ENDIF

   cBarra := Replicate( ::cComodin, nIncr )
   DevPos(::nFilaSup + 1, ::nColComodin) ; DevOut( cBarra, COLORCOM )
   DevPos(::nFilaSup + 2, ::nColPorcentaje)
   DevOutPict( ::nPorcAvanze, "999", COLORTIT )
   Set( _SET_DEVICE, cOldDev )

   RETURN( NIL )


/*
  Ŀ
 ݳ  DRAWENV()  Muestra entorno del Objeto.  
 
 
*/
METHOD drawEnv()
   ::calcCoord()         // Calcular coordenadas

   //... Salvar pantalla
   ::cScreen := SaveScreen(::nFilaSup, ::nColLeft, ::nFilaInf, ::nColRight)

   CajaConC( ::nFilaSup, ::nColLeft, ::nFilaInf, ::nColRight , "C" )
   DevPos(::nFilaSup, ::nColLeft + 2) ; DevOut( ::cTitulo, COLORTIT )
   DevPos(::nFilaSup + 1, ::nColComodin)
   DevOut( Replicate("", ::nLongBar), COLORBAR )
   DevPos(::nFilaSup + 2, ::nColPorcentaje + 3) ; DevOut( "%", COLORTIT )

   RETURN( NIL )


/*
  Ŀ
 ݳ  CALCCOORD()  Calcula coordenadas del Objeto.  
 
 
*/
METHOD calcCoord()
   ::nLongBar := Int( 100 / ::nPorcInc )
   ::nFilaInf := ::nFilaSup + 3
   ::nColLeft := (80 - (::nLongBar + 2)) / 2
   ::nColRight := ::nColLeft + ::nLongBar + 3
   ::nColComodin := ::nColLeft + 2
   ::nColPorcentaje := ::nColRight - 5

   RETURN( NIL )


/*
  Ŀ
 ݳ  CALCPORC()  Calcula porcentaje de avanze.  
 
 
*/
METHOD calcPorc()
   RETURN( ::nPorcAvanze := ( ::nCiclos / ::nLimite ) * 100 )



//... EOF( Gauge.prg )
